package eu.jonahbauer.wizard.client.libgdx.state;

import eu.jonahbauer.wizard.client.libgdx.Client;
import eu.jonahbauer.wizard.client.libgdx.screens.LoadingScreen;
import lombok.extern.log4j.Log4j2;

import java.util.Optional;

@Log4j2
public class AwaitingConnection extends Awaiting {
    
    @Override
    public Optional<ClientState> onEnter(Client client) {
        log.info("Awaiting connection...");
        client.getGame().setScreen(new LoadingScreen(client.getGame(), "menu.loading.connecting"));
        return super.onEnter(client);
    }
    
    @Override
    public Optional<ClientState> onOpen(Client client) {
        log.info("Connection established.");
        return Optional.of(new AwaitingJoinLobby());
    }
    
    @Override
    public Optional<ClientState> onClose(Client client, int code, String reason, boolean remote) {
        // TODO user feedback
        log.error("Connection could not be established. (code={}, reason={}, remote={})", code, reason, remote);
        return Optional.of(new Menu());
    }
}
