package eu.jonahbauer.wizard.common.messages.client;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NonNull;
import lombok.RequiredArgsConstructor;

import java.util.UUID;

@Getter
@RequiredArgsConstructor
@EqualsAndHashCode(callSuper = true)
public final class RejoinMessage extends ClientMessage {
    /**
     * UUID of the session
     */
    private final @NonNull UUID session;
    /**
     * UUID of the rejoining player
     */
    private final @NonNull UUID player;
    /**
     * Secret in order to assure that no malicious user wants to join the message
     */
    private final @NonNull String secret;
}
