package eu.jonahbauer.wizard.common.messages.data;

import eu.jonahbauer.wizard.common.model.Configuration;
import lombok.*;

import java.util.UUID;

@Getter
@RequiredArgsConstructor
@EqualsAndHashCode(of = "uuid")
@ToString
public class SessionData {
    /**
     * UUID of the session
     */
    private final @NonNull UUID uuid;
    /**
     * Name of the session
     */
    private final @NonNull String name;
    /**
     * Number of players currently in the session
     */
    private final int playerCount;
    /**
     * Configuration of the session
     */
    private final @NonNull Configuration configuration;
}
